;Program compiled by Great Cow BASIC (0.98.06 2019-06-12 (Windows 32 bit))
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F675, r=DEC
#include <P12F675.inc>
 __CONFIG _CP_OFF & _MCLRE_OFF & _WDTE_ON & _INTRC_OSC_NOCLKOUT

;********************************************************************************

;Set aside memory locations for variables
AUXA	EQU	36
AUXB	EQU	40
AUXC	EQU	42
AUXE	EQU	43
BUFFER_KEY	EQU	87
BUFFER_SER	EQU	78
CNTWDT	EQU	44
DELAYTEMP	EQU	32
DELAYTEMP2	EQU	33
SUM	EQU	45
SYSARRAYTEMP1	EQU	46
SYSARRAYTEMP2	EQU	47
SYSARRAYTEMP3	EQU	48
SYSBYTETEMPA	EQU	37
SYSBYTETEMPB	EQU	41
SYSBYTETEMPX	EQU	32
SYSSTRINGA	EQU	39
SYSTEMP1	EQU	49
SYSTEMP2	EQU	50
SYSWAITTEMPMS	EQU	34
SYSWAITTEMPMS_H	EQU	35
SYSWAITTEMPUS	EQU	37
SYSWAITTEMPUS_H	EQU	38

;********************************************************************************

;Alias variables
EEADDRESS	EQU	155
EEDATAVALUE	EQU	154
SYSBUFFER_KEY_0	EQU	87
SYSBUFFER_KEY_1	EQU	88
SYSBUFFER_KEY_2	EQU	89
SYSBUFFER_KEY_3	EQU	90
SYSBUFFER_KEY_4	EQU	91
SYSBUFFER_KEY_5	EQU	92
SYSBUFFER_KEY_6	EQU	93
SYSBUFFER_KEY_7	EQU	94
SYSBUFFER_SER_0	EQU	78
SYSBUFFER_SER_1	EQU	79
SYSBUFFER_SER_2	EQU	80
SYSBUFFER_SER_3	EQU	81
SYSBUFFER_SER_4	EQU	82
SYSBUFFER_SER_5	EQU	83
SYSBUFFER_SER_6	EQU	84
SYSBUFFER_SER_7	EQU	85

;********************************************************************************

;Vectors
	ORG	0
	pagesel	BASPROGRAMSTART
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;************************************************************************************************************
;TX_BLOQUEADOR_V2
;Autor: Claudio Lrios
;Data: 03/08/2020
;Transmissor para ser usado em conjunto com o receptor 'RX_PRESENCA_V2'
;Funcionamento: A cada 45 segundos este dispositivo emite uma transmisso de
;forma automtica. O usurio dever ficar com este transmissor junto do seu
;corpo. No deve ficar junto com as chaves do veculo, mas como um
;'chaveirinho' separado.
;Ele transmitir para o receptor instalado no veculo (moto ou carro).
;O receptor (RX_BLOQUEADOR_V2) ir  acionar um rele  ou manter ele ligado
;cada vez que recebe a transmisso do tx.
;Este rele dever controlar a bomba de combustivel ou a bobina de ignio do
;veculo. O objetivo  imobilizar o veculo em caso de roubo, quando o dono do
;veculo  liberado e o veculo levado. Se ele continuar em poder dos meliantes
;o sistema permitir que tudo funcione normalmente.
;Quando o usurio se afastar do receptor, a sua transmisso no ser mais captada
;levando o receptor, aps um tempo definido, desligar o rele do receptor e
;imobilizar o veculo.
;Ateno: O uso de dispositivos de segurana que cortem o combustvel ou a
;ignio do veculo podem causar acidentes. O uso deste dispositivo  por
;conta e risco do usurio. Verifique a legislao de transito de sua
;localidade sobre a permisso do uso de dispositivos como este.
;Leve em conta a corrente que passar pelo rele. Use um de corrente apropriada
;a carga que estar controlando.
;A transmisso ser sempre diferente da anterior. Usa processo de encriptao
;com XOR + tabela de substituio.
;Este tx tem que ser cadastrado no receptor.
;Para isto:
;1)Aperte o boto 'gravar_ser' do receptor. O led acender. Nesta situao,
;o receptor fica aguardando um transmisso do nmero serial do transmissor.
;2)No transmissor, aperte o boto 'env_ser'. O led do receptor deve piscar e
;apagar, indicando o aprendizado.
;3)Desligue e religue a alimentao do transmissor. Dever transmitir e
;acionar o rele do receptor, liberando o funcionamento do veculo.
;Quando estiver longe do veculo ou no o estiver usando, desligue o
;transmissor para aumentar o tempo de vida til das pilhas.
;Tenha sempre no veculo algumas pilhas reservas.
;Poder tambm instalar um interruptor para eliminar o sistema em caso
;de pane. Dever ficar em um lugar escondido no veculo.
;Uso didtico
;Este arquivo  parte integrante do blog Picsource
;************************************************************************************************************
;BIT pinos do pic (tx mode)
;#define   rf_out  GPIO.0 'pino 7
;Dir       rf_out  out
	banksel	TRISIO
	bcf	TRISIO,0
;#define   bt_env_ser GPIO.5 'pino 2 boto p/ envio do serial number
;Dir       bt_env_ser  in
	bsf	TRISIO,5
;Escolha os valores abaixo diferente para cada cpia de tx controle remoto
;#define SER0  0X89
;#define SER1  0XAB
;#define SER2  0XCD
;#define SER3  0XEF
;#define SER4  lower  cnt
;#define SER5  higher cnt
;#define SER6  upper  cnt
;#define SER7  situao dos botes bit 0 e 1
;chave secreta (Key) - Use ela com os mesmos valores no tx e no rx
;#define KEY0  0X12
;#define KEY1  0X34
;#define KEY2  0X56
;#define KEY3  0X78
;#define KEY4  0X9A
;#define KEY5  0XBC
;#define KEY6  0XDE
;#define KEY7  0XF0
;defines
;#define N_ROTATE 64  'rotao do encript
;#define Q_TRANSMITIDO 6  'nmero de vezes que ocorre uma mesma transmisso
;variveis
;Dim buffer_Ser(8)'
;Dim buffer_Key(8)'
;Dim cntwdt as byte'
;Dim auxa as byte 'contadores auxiliares
;Dim auxb as byte '
;Dim auxc as byte '
;Dim auxd as byte '
;Dim auxe as byte
;Dim sum  as byte : sum = 0
	clrf	SUM
;************************************************************************************************************
;Rotina Main
;************************************************************************************************************
;OPTION_REG =  0b00001111' prescaller para wdt
	movlw	15
	movwf	OPTION_REG
;WPU = 0XFF 'liga pull ups individual
	movlw	255
	movwf	WPU
;CMCON = 7'desliga comparadores
	movlw	7
	banksel	CMCON
	movwf	CMCON
;TRISIO = 0b111110'
	movlw	62
	banksel	TRISIO
	movwf	TRISIO
;GPIO = 0
	banksel	GPIO
	clrf	GPIO
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;IOC = 0b100000
	movlw	32
	movwf	IOC
;INTCON = 0B00001000''liga interrupo de mudana de estado (pinos dos botes)
	movlw	8
	movwf	INTCON
;wait 100 ms
	movlw	100
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	banksel	STATUS
	call	Delay_MS
;tx_ao_ligar 'transmite ao ligar a alimentao do tx
	call	TX_AO_LIGAR
;************************************************************************************************************
;Lao de Repetio
;************************************************************************************************************
;do
SysDoLoop_S1
;transmitir ''rotina de transmisso temporizada (a cada 45 seg)
	call	TRANSMITIR
;loop
	goto	SysDoLoop_S1
SysDoLoop_E1
;************************************************************************************************************
;Sub-rotinas
;************************************************************************************************************
;************************************************************************************************************
;Encriptao
;************************************************************************************************************
;rotina de encriptao
;************************************************************************************************************
;Incrementa Contador de Encriptao
;************************************************************************************************************
;************************************************************************************************************
;Envio de dados para o Transmissor comercial
;************************************************************************************************************
;************************************************************************************************************
;Rotina de Transmisso do Serial Number para aprendizado do RX
;************************************************************************************************************
;*********************************************************************************************************
;Rotina de Transmisso de dados
;*********************************************************************************************************
;rotina de modulaao da transmisso de rf no tx
;#define VALOR_TRANSMITIR 19 ' VALOR_TRANSMITIR=Tempo desejado em seg /2,304
;************************************************************************************************************
;Transmite ao ligar alimentao
;************************************************************************************************************
;************************************************************************************************************
;fim do programa
;************************************************************************************************************
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	142
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	1
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

ENVIA_DADOS
;transmite lsb primeiro
;for auxb = 1 to Q_TRANSMITIDO
	clrf	AUXB
SysForLoop4
	incf	AUXB,F
;rf_out = 1''pulso de start
	bsf	GPIO,0
;wait 330 us'
	movlw	110
	movwf	DELAYTEMP
DelayUS1
	decfsz	DELAYTEMP,F
	goto	DelayUS1
;rf_out = 0'
	bcf	GPIO,0
;for auxa = 0 to 63
	movlw	255
	movwf	AUXA
SysForLoop5
	incf	AUXA,F
;clrwdt '
	clrwdt
;if (buffer_Ser(0) and 1) = 1 then 'envia '1'
	movlw	1
	andwf	SYSBUFFER_SER_0,W
	movwf	SysTemp1
	movwf	SysBYTETempA
	movlw	1
	movwf	SysBYTETempB
	call	SysCompEqual
	btfss	SysByteTempX,0
	goto	ELSE11_1
;rf_out = 0'
	bcf	GPIO,0
;wait 660 us'
	movlw	220
	movwf	DELAYTEMP
DelayUS2
	decfsz	DELAYTEMP,F
	goto	DelayUS2
;rf_out = 1'
	bsf	GPIO,0
;wait 330 us'
	movlw	110
	movwf	DELAYTEMP
DelayUS3
	decfsz	DELAYTEMP,F
	goto	DelayUS3
;rf_out = 0'
	bcf	GPIO,0
;else 'envia '0'
	goto	ENDIF11
ELSE11_1
;rf_out = 0'
	bcf	GPIO,0
;wait 330 us'
	movlw	110
	movwf	DELAYTEMP
DelayUS4
	decfsz	DELAYTEMP,F
	goto	DelayUS4
;rf_out = 1'
	bsf	GPIO,0
;wait 660 us'
	movlw	220
	movwf	DELAYTEMP
DelayUS5
	decfsz	DELAYTEMP,F
	goto	DelayUS5
;rf_out=0'
	bcf	GPIO,0
;end if
ENDIF11
;rotate_right(buffer_Ser,8)''rotaciona 1 bits a direita
;C = buffer_Ser(0) and 1
;auxc = buffer_Ser(0)
	movf	SYSBUFFER_SER_0,W
	movwf	AUXC
;C = 0
	bcf	STATUS,C
;if auxc.0 = 1 then
	btfsc	AUXC,0
;C = 1
	bsf	STATUS,C
;End if
;rotate  buffer_Ser(7) right
	rrf	SYSBUFFER_SER_7,F
;rotate  buffer_Ser(6) right
	rrf	SYSBUFFER_SER_6,F
;rotate  buffer_Ser(5) right
	rrf	SYSBUFFER_SER_5,F
;rotate  buffer_Ser(4) right
	rrf	SYSBUFFER_SER_4,F
;rotate  buffer_Ser(3) right
	rrf	SYSBUFFER_SER_3,F
;rotate  buffer_Ser(2) right
	rrf	SYSBUFFER_SER_2,F
;rotate  buffer_Ser(1) right
	rrf	SYSBUFFER_SER_1,F
;rotate  buffer_Ser(0) right
	rrf	SYSBUFFER_SER_0,F
;next
	movlw	63
	subwf	AUXA,W
	btfss	STATUS, C
	goto	SysForLoop5
SysForLoopEnd5
;wait 7 ms''delay entre transmisses
	movlw	7
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;next
	movlw	6
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop4
SysForLoopEnd4
	return

;********************************************************************************

EPWRITE
;Variable alias
;Dim EEAddress Alias EEADR  'erv
;Dim EEDataValue Alias EEDATL_REF
;Disable interrupt
;IntOff
;Select data memory
;Start write
;SET WREN ON
	banksel	EECON1
	bsf	EECON1,WREN
;EECON2 = 0x55
	movlw	85
	movwf	EECON2
;EECON2 = 0xAA
	movlw	170
	movwf	EECON2
;SET WR ON
	bsf	EECON1,WR
;SET WREN OFF
	bcf	EECON1,WREN
;Wait for write to complete
;WAIT WHILE WR ON
SysWaitLoop1
	btfsc	EECON1,WR
	goto	SysWaitLoop1
;SET WREN OFF
	bcf	EECON1,WREN
;Restore interrupt
;IntOn
	banksel	STATUS
	return

;********************************************************************************

INCREMENTA_CNT
;incrementa contador da encriptao
;clrwdt'
	clrwdt
;auxc =read_eeprom(0)'
;EPRead 0, auxc  'auxc tem o valor lido na eeprom
	banksel	EEADDRESS
	clrf	EEADDRESS
	banksel	STATUS
	call	SYSEPREAD
	banksel	EEDATAVALUE
	movf	EEDATAVALUE,W
	movwf	AUXC
;auxc = auxc + 1
	incf	AUXC,F
;write_eeprom(0,auxc)'
;EPWrite 0, auxc '
	clrf	EEADDRESS
	movf	AUXC,W
	movwf	EEDATAVALUE
	banksel	STATUS
	call	EPWRITE
;if auxc = 0 then
	movf	AUXC,F
	btfss	STATUS, Z
	goto	ENDIF9
;auxc=read_eeprom(1)'
;EPRead 1, auxc
	movlw	1
	banksel	EEADDRESS
	movwf	EEADDRESS
	banksel	STATUS
	call	SYSEPREAD
	banksel	EEDATAVALUE
	movf	EEDATAVALUE,W
	movwf	AUXC
;auxc = auxc + 1
	incf	AUXC,F
;write_eeprom(1,auxc)'
;EPWrite 1, auxc '
	movlw	1
	movwf	EEADDRESS
	movf	AUXC,W
	movwf	EEDATAVALUE
	banksel	STATUS
	call	EPWRITE
;if auxc = 0 then
	movf	AUXC,F
	btfss	STATUS, Z
	goto	ENDIF10
;auxc=read_eeprom(2)'
;EPRead 2, auxc
	movlw	2
	banksel	EEADDRESS
	movwf	EEADDRESS
	banksel	STATUS
	call	SYSEPREAD
	banksel	EEDATAVALUE
	movf	EEDATAVALUE,W
	movwf	AUXC
;auxc = auxc + 1'
	incf	AUXC,F
;write_eeprom(2,auxc)'
;EPWrite 2, auxc '
	movlw	2
	movwf	EEADDRESS
	movf	AUXC,W
	movwf	EEDATAVALUE
	banksel	STATUS
	call	EPWRITE
;end if
ENDIF10
;end if
ENDIF9
	return

;********************************************************************************

INITSYS
;Resolve OSCCAL calibration
;GCB does not load saved calibration data into OSCCAL register on Baseline PIC. Therefore the FOSC is inaccurate when using internal RC oscillator.
;Solution:  Add following as the FIRST lines in the INITSYS sub in the System.h file
;This loads the saved calibration data from the last flash memory location at POR or any time the chip is reset.
;CALL 0x3ff
	call	1023
;movwf osccal
	banksel	OSCCAL
	movwf	OSCCAL
;Set up internal oscillator
;Handle OSCCON1 register for parts that have this register
;Ensure all ports are set for digital I/O and, turn off A/D
;SET ADFM OFF
	banksel	ADCON0
	bcf	ADCON0,ADFM
;Switch off A/D Var(ADCON0)
;SET ADCON0.ADON OFF
	bcf	ADCON0,ADON
;Commence clearing any ANSEL variants in the part
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;End clearing any ANSEL variants in the part
;Turn off comparator - this is the default setting
;CMCON = 7
	movlw	7
	banksel	CMCON
	movwf	CMCON
;Turn off all ports
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

SYSCOMPEQUAL
;Dim SysByteTempA, SysByteTempB, SysByteTempX as byte
;clrf SysByteTempX
	clrf	SYSBYTETEMPX
;movf SysByteTempA, W
	movf	SYSBYTETEMPA, W
;subwf SysByteTempB, W
	subwf	SYSBYTETEMPB, W
;btfsc STATUS, Z
	btfsc	STATUS, Z
;comf SysByteTempX,F
	comf	SYSBYTETEMPX,F
	return

;********************************************************************************

SYSEPREAD
;Variable alias
;Dim EEAddress Alias EEADR
;Dim EEDataValue Alias EEDATL_REF
;Disable interrupt
;IntOff
;Select data memory
;Read
;SET RD ON
	banksel	EECON1
	bsf	EECON1,RD
;Restore interrupt
;IntOn
	banksel	STATUS
	return

;********************************************************************************

TABELAK
	movlw	17
	subwf	SysStringA, W
	btfsc	STATUS, C
	retlw	0
	movf	SysStringA, W
	addlw	low TableTABELAK
	movwf	SysStringA
	movlw	high TableTABELAK
	btfsc	STATUS, C
	addlw	1
	movwf	PCLATH
	movf	SysStringA, W
	movwf	PCL
TableTABELAK
	retlw	16
	retlw	8
	retlw	5
	retlw	11
	retlw	15
	retlw	0
	retlw	2
	retlw	14
	retlw	1
	retlw	13
	retlw	3
	retlw	4
	retlw	6
	retlw	7
	retlw	9
	retlw	10
	retlw	12

;********************************************************************************

TRANSMITE_SERIAL_NUMBER
;sum = 0
	clrf	SUM
;buffer_Ser(0) = SER0'
	movlw	137
	movwf	SYSBUFFER_SER_0
;sum = sum + SER0'
	movlw	137
	addwf	SUM,F
;buffer_Ser(1) = SER1'
	movlw	171
	movwf	SYSBUFFER_SER_1
;sum = sum + SER1'
	movlw	171
	addwf	SUM,F
;buffer_Ser(2) = SER2'
	movlw	205
	movwf	SYSBUFFER_SER_2
;sum = sum + SER2'
	movlw	205
	addwf	SUM,F
;buffer_Ser(3) = SER3'
	movlw	239
	movwf	SYSBUFFER_SER_3
;sum = sum + SER3'
	movlw	239
	addwf	SUM,F
;EPRead 0, buffer_Ser(4)'cnt lower
	banksel	EEADDRESS
	clrf	EEADDRESS
	banksel	STATUS
	call	SYSEPREAD
	banksel	EEDATAVALUE
	movf	EEDATAVALUE,W
	banksel	SYSBUFFER_SER_4
	movwf	SYSBUFFER_SER_4
;sum = sum + buffer_Ser(4)'cnt higher
	addwf	SUM,F
;EPRead 1, buffer_Ser(5)'cnt upper
	movlw	1
	banksel	EEADDRESS
	movwf	EEADDRESS
	banksel	STATUS
	call	SYSEPREAD
	banksel	EEDATAVALUE
	movf	EEDATAVALUE,W
	banksel	SYSBUFFER_SER_5
	movwf	SYSBUFFER_SER_5
;sum = sum + buffer_Ser(5)'
	addwf	SUM,F
;EPRead 2, buffer_Ser(6)
	movlw	2
	banksel	EEADDRESS
	movwf	EEADDRESS
	banksel	STATUS
	call	SYSEPREAD
	banksel	EEDATAVALUE
	movf	EEDATAVALUE,W
	banksel	SYSBUFFER_SER_6
	movwf	SYSBUFFER_SER_6
;sum = sum + buffer_Ser(6)'
	addwf	SUM,F
;buffer_Ser(7) = sum'somatria
	movf	SUM,W
	movwf	SYSBUFFER_SER_7
;envia_dados 'envia dados pelo pino de sada do pic (rf_out)
	goto	ENVIA_DADOS

;********************************************************************************

TRANSMITIR
;sleep ''sleep mode
	sleep
;wait 3 us'
	goto	$+1
	nop
;if bt_env_ser = 0 then
	btfsc	GPIO,5
	goto	ELSE1_1
;do while  bt_env_ser = 0
SysDoLoop_S2
	btfsc	GPIO,5
	goto	SysDoLoop_E2
;clrwdt '
	clrwdt
;transmite_serial_number ''transmite serial number para aprendizado do rx
	call	TRANSMITE_SERIAL_NUMBER
;wait 50 ms
	movlw	50
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;loop
	goto	SysDoLoop_S2
SysDoLoop_E2
;else
	goto	ENDIF1
ELSE1_1
;if status.4 = 0 then  'TO bit 4
	btfsc	STATUS,4
	goto	ELSE2_1
;cntwdt = cntwdt + 1
	incf	CNTWDT,F
;if cntwdt >= VALOR_TRANSMITIR then
	movlw	19
	subwf	CNTWDT,W
	btfss	STATUS, C
	goto	ENDIF3
;cntwdt = 0'
	clrf	CNTWDT
;Se uma transmisso no for bem recebida, o rx ficar dessincronizado.
;Por preveno, envia-se 2 vezes para poder ressincronizar rx, caso seja
;o caso.
;tx_encripta ''embaralha dados da serial, contador e botes
	call	TX_ENCRIPTA
;envia_dados ''envia dados pelo pino de sada do pic (rf_out)
	call	ENVIA_DADOS
;incrementa_cnt ''incrementa contador da encriptao
	call	INCREMENTA_CNT
;wait 100 ms'
	movlw	100
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;tx_encripta ''embaralha dados da serial, contador e botes
	call	TX_ENCRIPTA
;envia_dados ''envia dados pelo pino de sada do pic (rf_out)
	call	ENVIA_DADOS
;incrementa_cnt ''incrementa contador da encriptao
	call	INCREMENTA_CNT
;end if
ENDIF3
;else
	goto	ENDIF2
ELSE2_1
;cntwdt = 0''zera no power_on reset
	clrf	CNTWDT
;end if
ENDIF2
;end if
ENDIF1
	return

;********************************************************************************

TX_AO_LIGAR
;if status.4 = 1 then  ' TO bit - verifica se foi reset normal ou reset por wtd
	btfss	STATUS,4
	goto	ENDIF4
;cntwdt = 0''zera
	clrf	CNTWDT
;tx_encripta ''embaralha dados da serial, contador e botes
	call	TX_ENCRIPTA
;envia_dados ''envia dados pelo pino de sada do pic (rf_out)
	call	ENVIA_DADOS
;incrementa_cnt ''incrementa contador da encriptao
	call	INCREMENTA_CNT
;wait 100 ms'
	movlw	100
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;tx_encripta ''embaralha dados da serial, contador e botes
	call	TX_ENCRIPTA
;envia_dados ''envia dados pelo pino de sada do pic (rf_out)
	call	ENVIA_DADOS
;incrementa_cnt ''incrementa contador da encriptao
	call	INCREMENTA_CNT
;end if
ENDIF4
	return

;********************************************************************************

TX_ENCRIPTA
;buffer_Ser(0) = SER0'
	movlw	137
	movwf	SYSBUFFER_SER_0
;buffer_Ser(1) = SER1'
	movlw	171
	movwf	SYSBUFFER_SER_1
;buffer_Ser(2) = SER2'
	movlw	205
	movwf	SYSBUFFER_SER_2
;buffer_Ser(3) = SER3'
	movlw	239
	movwf	SYSBUFFER_SER_3
;EPRead 0, buffer_Ser(4) 'cnt lower
	banksel	EEADDRESS
	clrf	EEADDRESS
	banksel	STATUS
	call	SYSEPREAD
	banksel	EEDATAVALUE
	movf	EEDATAVALUE,W
	banksel	SYSBUFFER_SER_4
	movwf	SYSBUFFER_SER_4
;EPRead 1, buffer_Ser(5) 'cnt higher
	movlw	1
	banksel	EEADDRESS
	movwf	EEADDRESS
	banksel	STATUS
	call	SYSEPREAD
	banksel	EEDATAVALUE
	movf	EEDATAVALUE,W
	banksel	SYSBUFFER_SER_5
	movwf	SYSBUFFER_SER_5
;EPRead 2, buffer_Ser(6)'cnt upper
	movlw	2
	banksel	EEADDRESS
	movwf	EEADDRESS
	banksel	STATUS
	call	SYSEPREAD
	banksel	EEDATAVALUE
	movf	EEDATAVALUE,W
	banksel	SYSBUFFER_SER_6
	movwf	SYSBUFFER_SER_6
;buffer(7) ajustado com botes no bits 0 e 1
;Carrega valores da Key de Encriptao
;buffer_Key(0) = KEY0'
	movlw	18
	movwf	SYSBUFFER_KEY_0
;buffer_Key(1) = KEY1'
	movlw	52
	movwf	SYSBUFFER_KEY_1
;buffer_Key(2) = KEY2'
	movlw	86
	movwf	SYSBUFFER_KEY_2
;buffer_Key(3) = KEY3'
	movlw	120
	movwf	SYSBUFFER_KEY_3
;buffer_Key(4) = KEY4'
	movlw	154
	movwf	SYSBUFFER_KEY_4
;buffer_Key(5) = KEY5'
	movlw	188
	movwf	SYSBUFFER_KEY_5
;buffer_Key(6) = KEY6'
	movlw	222
	movwf	SYSBUFFER_KEY_6
;buffer_Key(7) = KEY7'
	movlw	240
	movwf	SYSBUFFER_KEY_7
;loop de encriptao
;for auxa = 1 to N_ROTATE
	clrf	AUXA
SysForLoop1
	incf	AUXA,F
;clrwdt 'clear wtd
	clrwdt
;for auxb = 0 to 7
	movlw	255
	movwf	AUXB
SysForLoop2
	incf	AUXB,F
;buffer_Ser(auxb)= buffer_Ser(auxb) xor buffer_Key(auxb)'
	movlw	low(BUFFER_KEY)
	addwf	AUXB,W
	movwf	FSR
	movf	INDF,W
	movwf	SysArrayTemp1
	movlw	low(BUFFER_SER)
	addwf	AUXB,W
	movwf	FSR
	movf	INDF,W
	movwf	SysArrayTemp3
	xorwf	SysArrayTemp1,W
	movwf	SysArrayTemp2
	movlw	low(BUFFER_SER)
	addwf	AUXB,W
	movwf	FSR
	movf	SysArrayTemp2,W
	movwf	INDF
;next
	movlw	7
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;rotate_right(buffer_Ser,8)''rotaciona 1 bits a direita
;C = buffer_Ser(0) and 1
	movlw	1
	andwf	SYSBUFFER_SER_0,W
	movwf	SysTemp1
	bcf	STATUS,C
	btfsc	SysTemp1,0
	bsf	STATUS,C
;rotate  buffer_Ser(7) right
	rrf	SYSBUFFER_SER_7,F
;rotate  buffer_Ser(6) right
	rrf	SYSBUFFER_SER_6,F
;rotate  buffer_Ser(5) right
	rrf	SYSBUFFER_SER_5,F
;rotate  buffer_Ser(4) right
	rrf	SYSBUFFER_SER_4,F
;rotate  buffer_Ser(3) right
	rrf	SYSBUFFER_SER_3,F
;rotate  buffer_Ser(2) right
	rrf	SYSBUFFER_SER_2,F
;rotate  buffer_Ser(1) right
	rrf	SYSBUFFER_SER_1,F
;rotate  buffer_Ser(0) right
	rrf	SYSBUFFER_SER_0,F
;rotina de substituio de valores
;for auxb = 0 to 7
	movlw	255
	movwf	AUXB
SysForLoop3
	incf	AUXB,F
;auxc = buffer_Ser(auxb) and 0x0f'
	movlw	low(BUFFER_SER)
	addwf	AUXB,W
	movwf	FSR
	movlw	15
	andwf	INDF,W
	movwf	AUXC
;auxc = auxc + 1 'ajusta para ler tabela
	incf	AUXC,F
;buffer_Ser(auxb) = buffer_Ser(auxb) and 0xf0''zera 4 bits low
	movlw	low(BUFFER_SER)
	addwf	AUXB,W
	movwf	FSR
	movf	INDF,W
	movwf	SysArrayTemp2
	movlw	240
	andwf	SysArrayTemp2,W
	movwf	SysArrayTemp1
	movlw	low(BUFFER_SER)
	addwf	AUXB,W
	movwf	FSR
	movf	SysArrayTemp1,W
	movwf	INDF
;ReadTable TABELAK, auxc, auxe
	movf	AUXC,W
	movwf	SYSSTRINGA
	call	TABELAK
	movwf	AUXE
;buffer_Ser(auxb) = buffer_Ser(auxb) or auxe '
	movlw	low(BUFFER_SER)
	addwf	AUXB,W
	movwf	FSR
	movf	INDF,W
	movwf	SysArrayTemp2
	iorwf	AUXE,W
	movwf	SysArrayTemp1
	movlw	low(BUFFER_SER)
	addwf	AUXB,W
	movwf	FSR
	movf	SysArrayTemp1,W
	movwf	INDF
;next
	movlw	7
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop3
SysForLoopEnd3
;next
	movlw	64
	subwf	AUXA,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
	return

;********************************************************************************


 END
